#ifndef EFFECT_H
#define EFFECT_H

#include <d3d11.h>

/// <summary>
/// Base class for using the rendering pipeline
/// </summary>
class Effect
{
  public:
    /// <summary>
    /// Creates an effect
    /// </summary>
    Effect();
    
    /// <summary>
    /// Cleans up the effect
    /// </summary>
    virtual ~Effect();
    
    /// <summary>
    /// Setups the effect to be used for rendering
    /// <summary>
    /// <param name="context">
    /// D3D11 context to apply the effect to
    /// </param>
    virtual void MakeActive(ID3D11DeviceContext* context) = 0;
    
  private:
    // disabled
    Effect(const Effect& cpy);
    Effect& operator=(const Effect& cpy);
};

#endif /* EFFECT_H */
