#ifndef SHADERMODEL_H
#define SHADERMODEL_H

/// <summary>
/// Enum of the various shader models supported by this framework
/// </summary>
enum ShaderModel
{
  SM_2_0 = 0,
  SM_3_0,
  SM_4_0,
  SM_5_0,
};

/// <summary>
/// Converts entries of the ShaderModel enum to their associated string for
/// vertex shaders
/// </summary>
/// <param name="model">
/// entry in ShaderModel to convert
/// </param>
/// <returns>
/// the corresponding string to the model
/// </returns>
const char* ShaderModelToVertexModel(ShaderModel model);

/// <summary>
/// Converts entries of the ShaderModel enum to their associated string for
/// pixel shaders
/// </summary>
/// <param name="model">
/// entry in ShaderModel to convert
/// </param>
/// <returns>
/// the corresponding string to the model
/// </returns>
const char* ShaderModelToPixelModel(ShaderModel model);

#endif /* SHADERMODEL_H */
