#include "Buffers/InstanceBuffer.h"

InstanceBuffer* InstanceBuffer::Create(D3D11_Core& graphics,UINT num,UINT size,
  const void* data)
{
  ID3D11Buffer* tmp = CreateBuffer(graphics,num,size,true,data);
  if (tmp == NULL)
  {
    return NULL;
  }
  
  return new InstanceBuffer(tmp,size,num);
}

InstanceBuffer::InstanceBuffer(ID3D11Buffer* buffer,UINT size,UINT num)
:VertexBuffer(buffer,num),
 m_stride(size),
 m_num_bytes(size * num)
{
}

InstanceBuffer::~InstanceBuffer()
{
}

bool InstanceBuffer::Update(ID3D11DeviceContext* context,const void* data)
{
  D3D11_MAPPED_SUBRESOURCE mapped;
  if (FAILED(context->Map(m_buffer,0,D3D11_MAP_WRITE_DISCARD,0,&mapped)))
  {
    return false;
  }
  
  memcpy(mapped.pData,data,m_num_bytes);
  
  context->Unmap(m_buffer,0);
  
  return true;
}

UINT InstanceBuffer::GetStride() const
{
  return m_stride;
}
