//--------------------------------------------------------------------------------------
// File: Tutorial07.fx
//
// Copyright (c) Microsoft Corporation. All rights reserved.
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
// Constant Buffer Variables
//--------------------------------------------------------------------------------------
Texture2D txDiffuse : register( t0 );
SamplerState samLinear : register( s0 );

cbuffer cbNeverChanges : register( b0 )
{
  matrix wvp;
};


//--------------------------------------------------------------------------------------
struct VS_INPUT
{
  float4 pos : POSITION;
  float2 uv : TEXCOORD0;
};

struct PS_INPUT
{
  float4 pos : SV_POSITION;
  float2 uv : TEXCOORD0;
};


//--------------------------------------------------------------------------------------
// Vertex Shader
//--------------------------------------------------------------------------------------
PS_INPUT VS(VS_INPUT input,float3 instance_pos : TEXCOORD1)
{
  PS_INPUT output;
  output.pos = mul(input.pos + float4(instance_pos,0), wvp);
  output.uv = input.uv;
    
  return output;
}


//--------------------------------------------------------------------------------------
// Pixel Shader
//--------------------------------------------------------------------------------------
float4 PS(PS_INPUT input) : SV_Target
{
  return txDiffuse.Sample(samLinear,input.uv);
  //return float4(1,0,0,1);
}
